uint8_t HYT_221_read(uint8_t * data)
{
uint32_t t;
int16_t  temperatur;
uint16_t humidity;
uint8_t  buffer[6];
uint8_t  i = 10;

while(1)
	{
	buffer[0] = HYT221_ADR;						// Adresse fr TWI-Write
	TWI_MA_Start_Transceiver_With_Data(buffer, 1);

	if (!(TWI_LastTransOK()))					// Prfen, ob der Slave ein ACK gesendet hat
		{
		return(0);									// wenn nicht, dann beenden
		}

	delay_10ms(10);								// Wartezeit 100ms (50ms reicht nicht aus)

	buffer[0]++;									// Adresse fr TWI-Read incrementieren
	TWI_MA_Start_Transceiver_With_Data(buffer, 5); // Daten via TWI einlesen
	TWI_MA_Get_Data_From_Transceiver(buffer, 5);// Daten abholen

	if (buffer[1]  & 0b11000000) 				// Bit.7/6 des ersten Datenbytes testen
		{
		i--;											// wenn gesetzt, dann ist der Sensor noch busy !
		}

	else												// wenn Bit.7/6 nicht gesetzt sind
		{
		break;										// die Schleife while(1) beenden
		}

	if (!(i))										// wenn i-Versuche erfolglos waren,
		{												// dann beenden
		return(0);									// Abbrechen
		}
	}

// ------------------------------------- 	Humidity konvertieren
t  = (buffer[1] << 8);							// Bit.7/6 sind nicht gesetzt !
t +=  buffer[2];
t *= 1000UL;										// mit 100 * 10 multiplizieren fr
t /= 16384UL;										// eine zustzliche Nachkommastelle !

humidity = (uint16_t) (t);

// ------------------------------------- Temperatur konvertieren
t  = buffer[3] << 8;
t += (buffer[4] & 0b00000011);				// Bit.1/0 maskieren ???
t *= 165;
t /= 16384L;

temperatur = (int16_t) (t - 40);

// ------------------------------------- die Werte (*10) speichern
i = 0;
data[i++] = (uint8_t) (humidity >> 8);
data[i++] = (uint8_t) (humidity);
data[i++] = (uint8_t) (temperatur >> 8);
data[i]   = (uint8_t) (temperatur);

return(4);											// Rckgabe der Anzahl geschriebener Bytes
